/**
  * ul_id = navigation id
  * pos = position on page (x,y)
  * size = size of one menu entry (width,height)
  *        width of all text, subs in px
  *        height of one entry
  * radius = start putting entries this far from the center
  * colors = array ([#normal,#blendto]) (only hex notation!)
  */


        
function check_z_index(e){
}
        
        
function CircleNav(ul_id, pos, size, radius, colors){
  var self = this;

  this.ul_id = ul_id;
  this.nav_ul = $(ul_id);
  this.pos = pos;
  this.size = size;
  this.radius = radius;
  this.colors = colors;

  this.first_lis = $(document.body).getElements("#"+this.ul_id+">li");
  this.first_count = this.first_lis.length;

  this.highest_angle = Math.floor(this.first_count/2)*30+10;

  this.morph_end = false;
  
  this.last_z_index = 300; //For Mouse Position z-index raising

  this.position_li = function(deg, size){
    self.pos;
    neg = 1;
    if (deg<0) neg = -1;
    deg = Math.abs(deg);
    x = (size[0]+self.radius)*Math.cos(deg*Math.PI/180);
    y = (size[0]+self.radius)*Math.sin(deg*Math.PI/180);
    
    if (neg>0){
      x -= size[1]/2*Math.sin(deg*Math.PI/180);
      y += size[1]/2*Math.cos(deg*Math.PI/180);
    } else {
      x += size[1]/2*Math.sin(deg*Math.PI/180);
      y -= size[1]/2*Math.cos(deg*Math.PI/180);
    }
    
    y *= neg;
    
    
    x = self.pos[0]-x;
    y = self.pos[1]-y;
    
    return [x,y];
  }


  this.delayed_blend_in = function(){
    if (self.morph_end != this) return;
    other_entries = this.getParent().getElements("li>a");
    other_entries.each(function(item){
      item.morph({
        width:item.old_width,
        'padding-left':5,
        'padding-right':5
      });
    });
    
  }

  this.delayed_blend_out = function(){
    first_a_child = this.getElement("a");
    this.setStyle("z-index",100);
    
    //Mouse based z-index raising
    self.last_z_index = 300;
    
    first_a_child.morph({
      'background-color': self.colors[0],
      'width': first_a_child.old_width
    });
  }

  this.first_lis.each( function(item,index){
    sub_count = item.getElements("li").length;
    width = self.size[0];
    height = self.size[1]*sub_count;
    angle = self.highest_angle-index*30;
    pos = self.position_li(angle,[width,height]);
    
    item.setStyles({
      display: "block",
      width: width,
      height: height,
      overflow:"hidden",
      position:"absolute",
      'z-index':100,
      left:pos[0],
      top:pos[1],
      '-webkit-transform': "rotate("+angle+"deg)",
      '-moz-transform': "rotate("+angle+"deg)",
      '-ms-transform': "rotate("+angle+"deg)",
      '-o-transform': "rotate("+angle+"deg)",
      '-webkit-transform-origin': "0 0",
      '-moz-transform-origin': "0 0",
      '-ms-transform-origin': "0 0",
      '-o-transform-origin': "0 0"
    });
    
    main_entrie = item.getElement("a");
    //main_entrie = main_entries[index];
    
    
    if (main_entrie.old_width==null) main_entrie.old_width = main_entrie.getSize().x - 20; //-10 because of padding!
    
    
    other_entries = item.getElements("li>a");
    
    other_entries.each(function(item){
      if (item.old_width==null)
      item.old_width = item.getSize().x; //no -20 because theres no padding at the begin!
      item.set('morph', {
        duration: 100
      });
      item.setStyle("width",0);
    });
    
    
    main_entrie.set('morph', {
      duration: 200
    }).addEvents({
      mouseenter: function(){
        this.getParent().setStyle("z-index",200);
        this.morph({
          'background-color': self.colors[1],
          'width': self.size[0]-130
        });
        
        self.morph_end = this;
        self.delayed_blend_in.delay(200,this);
        
        
        
      }
    });
    
    item.addEvents({
      mouseleave: function(){
        self.morph_end = false;
        other_entries = this.getElements("li>a");
        other_entries.each(function(item){
          item.morph({
            width:0,
            padding:0
          });
        });
      
        self.delayed_blend_out.delay(100,this);
        
        
      }
    });
    
    
    
    //Try to guess z-index order based on coordinates...
    
    item.main_pos = main_entrie.getPosition();
    item.main_size = main_entrie.getSize();
    
    //Save angle for later use in mousemove function
    item.angle = angle;
    //Calc Center Point
    if (angle<-90 || angle>90) angle=Math.abs(angle)-180; //mirror angle
    angle_rad = Math.abs(angle)*Math.PI/180;
    x_1 = item.main_size.x/2*Math.cos(angle_rad);
    y_1 = item.main_size.x/2*Math.sin(angle_rad);
    x_2 = item.main_size.y/2*Math.sin(angle_rad);
    y_2 = item.main_size.y/2*Math.cos(angle_rad);
    item.main_pos.x += Math.floor(x_1+x_2);
    item.main_pos.y += Math.floor(y_1+y_2);
    
    
    item.addEvents({
      mousemove: function(e){
        
        x = e.page.x;
        y = e.page.y;
        
        self.first_lis.each( function(item,index){
          //Center coord sys to box center
          x_tmp = x - item.main_pos.x;
          y_tmp = y - item.main_pos.y;
          
          //Rotate coord sys
          angle = item.angle*Math.PI/180;
          x_new = x_tmp * Math.cos(angle) + y_tmp * Math.sin(angle);
          y_new = -1 * x_tmp * Math.sin(angle) + y_tmp * Math.cos(angle);
          
          if (Math.abs(x_new)<=item.main_size.x/2&&Math.abs(y_new)<=item.main_size.y/2){
            item.setStyle("z-index",self.last_z_index) ;
            self.last_z_index++;
          }
        });
      }
    });
    
    
    
    
  });


  this.recalcPosition = function(pos){
    self.pos = pos;
    
    self.first_lis.each( function(item,index){
      sub_count = item.getElements("li").length;
      width = self.size[0];
      height = self.size[1]*sub_count;
      angle = self.highest_angle-index*30;
      pos = self.position_li(angle,[width,height]);
      
      item.setStyles({
        left:pos[0],
        top:pos[1]
      });
    });
  }
}